﻿//
import SD.RD;
import SGF.GamePiece;
import mx.transitions.Tween;
import mx.transitions.easing.*;
import  SH.Game.General;

//Can extend GamePiece or GameCollisionPiece
class GamePlay3.GamePlay3MC extends GamePiece{
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	
	//Private vars
	
	private var __contestants:Array;
	private var __contestantsXY:Array;
	private var __contestantScoresY:Array;
	private var __randomContestantScores:Array;
	private var __contestantsVisible:Number =0;
	private var __contestantsScoresVisible:Number =0;
	private var __myGeneral:General;
	
	
	//Sub MC Vars
	
	private var Round1Continue:MovieClip;
	private var QuestionsMC:MovieClip;
	private var messageLoose:MovieClip;
	private var messageWin:MovieClip;
	
	private var youSC:MovieClip;
	private var youImage:MovieClip;
	
	
	//Sub MC Buttons
	
	//private var b:Button;
	
	
	//Sub TextField vars
	
	//private var t:TextField;
	
	
	//Components
	
	
	
	
	//************************************************************
	//PUBLIC VARS
	//************************************************************
	
	//Public vars
	
	
	
	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	public function GamePlay3MC(){
		
		//RD.D("GameController Created", this);
		__linkageName = "GamePlay3MC";
		//makeThisADispatcher();
		//dispatchMyEvent("e_someEvent", {myMessage:"none"});
		
		__myGeneral = new General();
		__contestants = [{name:"megan", pos:[0,0]},
									{name:"justin", pos:[153,0]},
									{name:"shannon", pos:[306,0]},
									{name:"jason", pos:[0,148]},
									{name:"sarah", pos:[306,148]},
									{name:"randy", pos:[0,296.6]},
									{name:"danielle", pos:[153,296.6]},
									{name:"patrick", pos:[306,296.6]}];
												
		__randomContestantScores = [[1,1,1,1,1,"L"], [1,2,2,3,3,4], [1,1,2,2,2,2], [2,2,2,2,2,"L"], [2,3,4,4,5,6], [1,1,2,3,4,5], [1,1,1,2,2,"L"], [2,3,4,5,6,7]];
		
		__contestantsXY = [[0,0],
									[153,0],
									[306,0],
									[0,148],
									[306,148],
									[0,296.6],
									[153,296.6],
									[306,296.6]];
									
		__contestantScoresY = [198.7, 227.2, 255.7, 284.1, 312.6, 341.1, 369.6, 398.1]
									
		v_setup();
		
	}
		
		
		
		
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	
	//************************************************************
	//INITIAL FUNCTIONS: Usually functions off the constructor
	//************************************************************
	//this overides the scene director function which is called when a new scene containing this MC is loaded
	private function playScene(){
		
		getRef().RandomContestantScores = [{name:"megan", score:0},
																		{name:"justin", score:0},
																		{name:"shannon", score:0},
																		{name:"jason", score:0},
																		{name:"sarah", score:0},
																		{name:"randy", score:0},
																		{name:"danielle", score:0},
																		{name:"patrick", score:0}];
																		
		//scrampbe the fake scores
		getRef().RandomContestantScores = __myGeneral.scrambleArray(getRef().RandomContestantScores);
		__randomContestantScores = __myGeneral.scrambleArray(__randomContestantScores);
		for(var x = 0; x < getRef().RandomContestantScores.length; x++){
			
			getRef().RandomContestantScores[x].score = __randomContestantScores[x];
			
		}
		
		__contestants = __myGeneral.scrambleArray(__contestants);
		__contestantsXY = __myGeneral.scrambleArray(__contestantsXY);
		
		__contestantsVisible = 0;
		__contestantsScoresVisible = 0;
		v_setup();
		showGamePiece();
		v_display();
		
		
	}
	
	//this is called when the scene that this GamePiece is in is removed
	//Note when you call this you have to handle the removal of the GamePiece yourself
	//private function removeScene(){
		
		
	//}
	
	
	//using this function overrides the general hide scene hideGamePiece() function
	//so make sure you hide the GamePiece after running this function
	/*private function removeScene(){
		
		
	}*/
	
	
	private function initiate(){
		
		
	}
	
	//************************************************************
	//PUBLIC VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	
	//************************************************************
	//PRIVATE VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	
	//************************************************************
	//PUBLIC VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	public function enable(){
		
		
	}
	
	public function disable(){
		
		
	}

	//************************************************************
	//PRIVATE VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	
	
	private function v_setup(){
		
		v_resetScores();
		
		for(var x = 0; x < __contestants.length; x++){
			
			var tempMC:MovieClip = eval(this + "." + __contestants[x].name);
			tempMC._alpha = 0;
			tempMC._x = __contestantsXY[x][0];
			tempMC._y = __contestantsXY[x][1];
			
			tempMC = eval(this + "." + __contestants[x].name + "SC");
			tempMC._alpha = 0;
			tempMC._y = __contestantScoresY[x];
			
		}
		
		
		Round1Continue._visible = false;
		Round1Continue._alpha = 0;
		QuestionsMC._visible = false;
		messageLoose._visible = false;
		messageWin._visible = false;
		youImage._alpha = 0;
		youSC._alpha = 0;
		
	}
	
	
	
	private function v_display(){
		
		var myTween:Object = new Tween(youImage, "_alpha", Regular.easeOut, 0, 100, .6, true);
		var myTween1:Object = new Tween(youSC, "_alpha", Regular.easeOut, 0, 100, .6, true);
		
		//pause code
		var myFunc = function(callingMC:MovieClip){
								
			callingMC.v_display1();
								
		};
					
		pauseCodeAndCallFunction(.4, myFunc);
		
	}
	
	
	private function v_display1(){
		
		//call figures
		for(var x = 0; x < __contestants.length; x++){
					
			pauseCodeAndCallFunction((.2 * x), v_pauseFadeInContestant);
			
		}
		
		//call scores
		for(var x = 0; x < __contestants.length; x++){
					
			pauseCodeAndCallFunction(((.1 * x) + 1.6), v_pauseFadeInContestantScores);
			
		}
		
		
		//start questions
		var myFunc = function(callingMC:MovieClip){
								
			//callingMC.QuestionsMC._visible = true;
			//callingMC.QuestionsMC.v_start();
			callingMC.Round1Continue._visible = true
			var myTween:Object = new Tween(callingMC.Round1Continue, "_alpha", Regular.easeOut, 0, 100, .5, true);
			callingMC.Round1Continue.btn.enabled = true;
								
		};
					
		pauseCodeAndCallFunction(3.5, myFunc);
		
		
	}
	
	
	private function v_pauseFadeInContestant(callingMC:MovieClip){
		
		var tempMC:MovieClip = eval(callingMC + "." + callingMC.__contestants[callingMC.__contestantsVisible].name);
		callingMC.__contestantsVisible++;
		
		var myTween:Object = new Tween(tempMC, "_alpha", Regular.easeOut, tempMC._alpha, 100, .3, true);
		
	}
	
	
	private function v_pauseFadeInContestantScores(callingMC:MovieClip){
		
		var tempMC:MovieClip = eval(callingMC + "." + callingMC.__contestants[callingMC.__contestantsScoresVisible].name + "SC");
		callingMC.__contestantsScoresVisible++;
		
		var myTween:Object = new Tween(tempMC, "_alpha", Regular.easeOut, tempMC._alpha, 100, .2, true);
		
	}
	
	
	private function v_resetScores(){
		
		getRef().ScoreRound1 = 0;
		
		youSC.s.gotoAndStop(1);
		
		for(var x = 0; x < __contestants.length; x++){
			
			eval(this + "." + __contestants[x].name + "SC").s.gotoAndStop(1);
			
		}
		
	}
	//************************************************************
	//PUBLIC CHARACTER FUNCTIONS: Functions that animate characters
	//************************************************************
	
	//************************************************************
	//PUBLIC CHARACTER SCRIPT FUNCTIONS: Functions called from outside which execute character animation scripts
	//************************************************************
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	
	//************************************************************
	//PRIVATE HELPER FUNCTIONS
	//************************************************************

	//____EVENTS_________________________________________________

	//************************************************************
	//REGULAR EVENT FUNCTIONS: Functions that fire off regular MC events like private function onRelease(){}
	//************************************************************

	//************************************************************
	//CUSTOM EVENT FUNCTIONS: Functions that fire off custom made dispatched events
	//************************************************************
	
	//User looses round1
	private function e_UserLooses(evt:Object){
		
		_level0.jdgSoundHandMC.fadeOutFast();
		getRef().gameSounds.playSound("breaker");
		messageLoose._visible = true;
		messageLoose._alpha = 0;
		var myTween:Object = new Tween(messageLoose, "_alpha", Regular.easeOut, 0, 100, .5, true);
		
	}
	
	//User wins round1 show the message just before going to next round
	private function e_UserNextRound(evt:Object){
		
		_level0.jdgSoundHandMC.fadeOutFast();
		getRef().gameSounds.playSound("breaker");
		messageWin._visible = true;
		messageWin._alpha = 0;
		var myTween:Object = new Tween(messageWin, "_alpha", Regular.easeOut, 0, 100, .5, true);
		
	}
	
	//User wins round1 show the message just before going to next round
	private function e_updateScores(evt:Object){
		
		youSC.s.gotoAndStop(Number(getRef().ScoreRound1 + 1));
		
		var questionNo:Number = evt.messageObject.questionCount;
		//update contestants
		for(var x = 0; x < getRef().RandomContestantScores.length; x++){
			
			var s:MovieClip = eval(this + "." + getRef().RandomContestantScores[x].name + "SC").s
				
			s.gotoAndStop(getRef().RandomContestantScores[x].score[questionNo]);
			
		}
	}
	
	//************************************************************
	//CUSTOM LOCAL EVENT FUNCTIONS: Functions that fire off events written into the fla of a MC like _parent.e_fireMyFunction();
	//************************************************************
	
	//called from Round1Continue (added by client)
	private function e_startQuestions(){
		
		Round1Continue.btn.enabled = false;
		var myTween:Object = new Tween(Round1Continue, "_alpha", Regular.easeOut, 100, 0, .5, true);
		
		//start questions
		var myFunc = function(callingMC:MovieClip){
								
			callingMC.QuestionsMC.v_start();
								
		};
					
		pauseCodeAndCallFunction(1, myFunc);
		
		
	}
	
	
	//user lost and asks to play again
	private function e_playAgain(){
		
		getRef().sceneDirector.playScene("scene2");
		
	}
	
	
		//user lost and asks to play again
	private function e_playRound2(){
		
		_level0.jdgSoundHandMC.startSoundtrack();
		getRef().sceneDirector.playScene("scene4");
		
	}
	
	
	private function e_exit(){
		
		getURL("javascript:self.close()");
		
	}
	
	//************************************************************
	//SUB MCs THAT FIRE FUNCTIONS: Functions that are called from .as files child MovieClips
	//************************************************************
	

}