import SGF.GamePiece;
import SGF.SceneDirector;
import SH.Game.Sounds;
import SB.Translator;
import SB.TranslatorHTML;
import SD.RD;


class Main
{
	static function main()
	{
		
		//*******************************************************************
		RD.D("----- Attach the InitMC to configure the application");
		//Remeber to edit the object's public variables when you wish to add information
		//This is for preloading with FlashDevelop as the Main.as needs a place on the timline to work
		var InitMC:MovieClip;
		if(_level0.emptyClip == null){
			
			InitMC = _root.attachMovie("PostInitMC", "PostInitMC", 2, {_x:0, _y:0, _visible:false});
			
		}else{
			
			InitMC = _level0.emptyClip.attachMovie("PostInitMC", "PostInitMC", 2, {_x:0, _y:0, _visible:false});
			
		}
		
		//*******************************************************************
		RD.D("----- Attaching Main Root Application MovieClips");
		//Remeber to edit the object's public variables when you wish to add information
		
		var host:MovieClip
		//This is for preloading with FlashDevelop as the Main.as needs a place on the timline to work
		if(_level0.emptyClip == null){
			
			host = _root.createEmptyMovieClip("host", 20, {_x:0, _y:0});
			
		}else{
			
			host = _level0.emptyClip.createEmptyMovieClip("host", 20, {_x:0, _y:0});
			
		}
		
		var GamePlay1MC:MovieClip = host.attachMovie("GamePlay1MC", "GamePlay1MC", 3, {_x:0, _y:0, _visible:false});
		var GamePlay2MC:MovieClip = host.attachMovie("GamePlay2MC", "GamePlay2MC", 4, {_x:0, _y:0, _visible:false});
		var GamePlay3MC:MovieClip = host.attachMovie("GamePlay3MC", "GamePlay3MC", 7, {_x:0, _y:0, _visible:false});
		var GamePlay4MC:MovieClip = host.attachMovie("GamePlay4MC", "GamePlay4MC", 9, {_x:0, _y:0, _visible:false});
		var GamePlay5MC:MovieClip = host.attachMovie("GamePlay5MC", "GamePlay5MC", 10, {_x:0, _y:0, _visible:false});
		var GamePlay6MC:MovieClip = host.attachMovie("GamePlay6MC", "GamePlay6MC", 112, {_x:0, _y:0, _visible:false});
		//*******************************************************************
		RD.D("----- End Attaching Main Root Application MovieClips");
		RD.D("");
		
		
		//*******************************************************************
		RD.D("----- Register Global Data Object");
		
		Ref.gI().host = host;
		Ref.gI().GamePlay1MC = GamePlay1MC;
		Ref.gI().GamePlay2MC = GamePlay2MC;
		Ref.gI().GamePlay3MC = GamePlay3MC;
		Ref.gI().GamePlay4MC = GamePlay4MC;
		Ref.gI().GamePlay5MC = GamePlay5MC;
		Ref.gI().GamePlay6MC = GamePlay6MC;
		
		//*******************************************************************
		RD.D("----- End Register Global Data Object");
		RD.D("");
		
		
		//*******************************************************************
		RD.D("----- Attach Game Sounds");

			var gameSounds:Sounds = new Sounds();
			gameSounds.addSound("breaker", "breaker", host, 100);
			gameSounds.addSound("question", "question", host, 100);
			gameSounds.addSound("correct", "correct", host, 100);
			gameSounds.addSound("incorrect", "incorrect", host, 100);
			Ref.gI().gameSounds = gameSounds;
			
		RD.D("----- End Attach Game Sounds");
		RD.D("");
		
		
		//*******************************************************************
		RD.D("----- Register Listeners - Top Level Objects");
				
			//var a_listenFor1:Object = {MC:_MainContentCMC, EVT:"e_requestContent"};
			//var a_listenFor2:Object = {MC:_LeftContentCMC, EVT:"e_requestContent"};
			//var a_listenFor3:Object = {MC:_RightContentCMC, EVT:"e_requestContent"};
			//_MenuCMC.registerListeners([a_listenFor1, a_listenFor2, a_listenFor3]);

		//*******************************************************************
		RD.D("----- End Register Listeners - Top Level Objects");
		RD.D("");
		
		
		//*******************************************************************
		RD.D("----- Register Collision Groups");
				
			//create collision group 1
			//var colGrp:Object = new Object();
			//colGrp.collisionGroupName = "collisionGroup1";
			//var members:Array = new Array();
			//members.push(".ejectedSlice");// note this MC is dynamically created in the ColourSlicesSecMC and ColourSlicesTerMC classes for collision with the programmer or artist
			//colGrp.preciseCollisionTest = true;
			//colGrp.collisionGroupMembers = members;

			//assign it to ProgrammerMC
			//programmerMC.CollisionGroups = colGrp;

			//*******************************************************************
			RD.D("----- End Register Collision Groups");
			RD.D("");
			
			var scene1:Array = [GamePlay1MC];
			var scene2:Array = [GamePlay2MC];
			var scene3:Array = [GamePlay3MC];
			var scene4:Array = [GamePlay4MC];
			var scene5:Array = [GamePlay5MC];
			var scene6:Array = [GamePlay6MC];

			//setup the scene controller, params are ordered in scene numeric
			var mySD:SceneDirector = new SceneDirector([scene1, scene2, scene3, scene4, scene5, scene6]);
			Ref.gI().sceneDirector = mySD;
			
	
			
	//*******************************************************************
	RD.D("----- Register The Global Data Object With GamePiece Super");
	var GP:GamePiece = new GamePiece();
	GP.setRef(Ref.gI());
			
	
	
	//*******************************************************************
	RD.D("----- Process the config.xml");
	//process the config.xml there is an event that will be caught in the PostInitMC to continue Initialisation
	Ref.gI().populateConfigRefData("datastorage/config.xml", [InitMC]);



	}
}
